# DS2 Core

## "Installation"

File                          | Processes to 
------------------------------|------------------------------
src/js/scaffolding.js         | public/assets/
src/scss/scaffolding.scss     | public/assets/
src/pg/core/core.scss.pug     | src/scss/
src/pg/core/download.php.pug  | public

All other pug files should compile to from src/pg/ to a relative path of public/*


## Running the core

functions

beforeArticleLoad - called before any patterns are started to load 
success - called when loading a pattern is successful if the result is an HTTP 200
afterArticleLoad - called after any patterns are started to load 
done - called when the ajax for any pattern is done, whether successful or not. This is a useful place to load any javascript initializations that pattern. 


## About the content variable

The content variable in \_config.pug defines your array of patterns. It is made up of the following attributes: 
- name - the hypenated name of the pattern
- status - this should be one of the statuses from your status array
- display - (optional) if present this will be displayed, as is, instead of the name
- template - (optional) [ pug (default) | md ] the file type of a pattern's index file
- core - (optional ) [ true | false ] if true, it will pull from the core folder
- files - (optional) an array of patterns under the parent. 

By changing and resaving the \_config.pug file, (our change is often adding or removing a random space) all of the pug patterns will recompile. Note that md templates will not recompile automatically when config is saved and updated as markdown files don't have an include. 

